import java.io.IOException;
import java.net.UnknownHostException;

public class commlib
{

    static
    {
	System.loadLibrary("ssslib_java");
    }

    private native void init_sss(String conffile,int debug);
    public ConfigDict dict;

    private int sss_ptr;

    public commlib(String conffile,int debug) throws Exception{
	init_sss(conffile,debug);
	dict = new ConfigDict(get_conf_string());
    }

    public native int SDRegister(String service,String host,int port,String protocol,String schema_version,String tier) throws UnknownHostException,IOException,SSS_InternalError;
    public native int SDRemove(String service,String host,int port,String protocol) throws UnknownHostException,IOException,SSS_InternalError;
    public native String ServerInit(int port) throws IOException,SSS_ProtocolException,SSS_InternalError;
    public native String ClientInit(String service) throws UnknownHostException,IOException,SSS_ProtocolException,SSS_InternalError;
    public native int ClientClose(String handle) throws IOException,SSS_InternalError;
    public native int ServerClose(String handle) throws IOException,SSS_InternalError;
    public native int SendMessage(String handle,String message) throws IOException,SSS_InternalError;
    public native String RecvMessage(String handle) throws IOException,SSS_InternalError;
    private native void native_finalize();
    private native String get_conf_string();
    protected void finalize()
    {
	native_finalize();
	try
	    {
		super.finalize();
	    }
	catch (Throwable e)
	    {
		System.err.println(e);
	    }
    }
}

